BaseComponentSpec (Gradle API 2.9)
Date: 2015-11-17

org.gradle.platform.base.component

## Class BaseComponentSpec

- java.lang.Object
- - org.gradle.platform.base.component.BaseComponentSpec

- All Implemented Interfaces:
    Named, ComponentSpec, org.gradle.platform.base.internal.ComponentSpecInternal

      @Incubating
      public abstract class BaseComponentSpec
      extends Object
      implements org.gradle.platform.base.internal.ComponentSpecInternal

  Base class for custom component implementations. A custom implementation of `ComponentSpec` must extend this type.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from interface org.gradle.api.Named

      `Named.Namer`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `protected` | `BaseComponentSpec()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `binaries(Action<? super ModelMap<BinarySpec>> action)` Configures the binaries that are produced for this component.
    `static <T extends BaseComponentSpec> T` | `create(Class<T> type, ComponentSpecIdentifier identifier, org.gradle.model.internal.core.MutableModelNode modelNode, org.gradle.internal.reflect.Instantiator instantiator, org.gradle.language.base.internal.registry.LanguageRegistry languageRegistry, File baseDir)`
    `ModelMap<BinarySpec>` | `getBinaries()` The binaries that are built for this component.
    `String` | `getDisplayName()` Returns a human-consumable display name for this component.
    `FunctionalSourceSet` | `getFunctionalSourceSet()`
    `Set<? extends Class<? extends TransformationFileType>>` | `getInputTypes()`
    `String` | `getName()` The object's name.
    `String` | `getProjectPath()` The path the the project containing this component.
    `ModelMap<LanguageSourceSet>` | `getSource()` The source sets that are used to build this component.
    `ModelMap<LanguageSourceSet>` | `getSources()` The source sets that are used to build this component.
    `protected String` | `getTypeName()`
    `void` | `sources(Action<? super ModelMap<LanguageSourceSet>> action)` Configures the source sets used to build this component.
    `String` | `toString()`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### BaseComponentSpec

          protected BaseComponentSpec()

  - ### Method Detail

    - #### create

          public static <T extends BaseComponentSpec> T create(Class<T> type,
                                               ComponentSpecIdentifier identifier,
                                               org.gradle.model.internal.core.MutableModelNode modelNode,
                                               org.gradle.internal.reflect.Instantiator instantiator,
                                               org.gradle.language.base.internal.registry.LanguageRegistry languageRegistry,
                                               File baseDir)

    - #### getName

          public String getName()

      Description copied from interface: `Named`
      The object's name.

      Must be constant for the life of the object.

      Specified by:
        `getName` in interface `Named`
      Returns:
        The name. Never null.

    - #### getProjectPath

          public String getProjectPath()

      Description copied from interface: `ComponentSpec`
      The path the the project containing this component.
      Specified by:
        `getProjectPath` in interface `ComponentSpec`

    - #### getTypeName

          protected String getTypeName()

    - #### getDisplayName

          public String getDisplayName()

      Description copied from interface: `ComponentSpec`
      Returns a human-consumable display name for this component.
      Specified by:
        `getDisplayName` in interface `ComponentSpec`

    - #### toString

          public String toString()

      Overrides:
        `toString` in class `Object`

    - #### getSource

          public ModelMap<LanguageSourceSet> getSource()

      Description copied from interface: `ComponentSpec`
      The source sets that are used to build this component.
      Specified by:
        `getSource` in interface `ComponentSpec`

    - #### getSources

          public ModelMap<LanguageSourceSet> getSources()

      Description copied from interface: `ComponentSpec`
      The source sets that are used to build this component.
      Specified by:
        `getSources` in interface `ComponentSpec`

    - #### sources

          public void sources(Action<? super ModelMap<LanguageSourceSet>> action)

      Description copied from interface: `ComponentSpec`
      Configures the source sets used to build this component.
      Specified by:
        `sources` in interface `ComponentSpec`

    - #### getBinaries

          public ModelMap<BinarySpec> getBinaries()

      Description copied from interface: `ComponentSpec`
      The binaries that are built for this component. You can use this to configure the binaries for this component.
      Specified by:
        `getBinaries` in interface `ComponentSpec`

    - #### binaries

          public void binaries(Action<? super ModelMap<BinarySpec>> action)

      Description copied from interface: `ComponentSpec`
      Configures the binaries that are produced for this component.
      Specified by:
        `binaries` in interface `ComponentSpec`

    - #### getFunctionalSourceSet

          public FunctionalSourceSet getFunctionalSourceSet()

      Specified by:
        `getFunctionalSourceSet` in interface `org.gradle.platform.base.internal.ComponentSpecInternal`

    - #### getInputTypes

          public Set<? extends Class<? extends TransformationFileType>> getInputTypes()

      Specified by:
        `getInputTypes` in interface `org.gradle.platform.base.internal.ComponentSpecInternal`